﻿Imports Edtter.utility
Imports System.Xml
Imports Microsoft.Win32

Public Class frmFriendsTimeline

    Public Shared user As String
    Public Shared pass As String
    Public Const friendsTimelineUrl As String = "http://twitter.com/statuses/friends_timeline.xml"

    '(1) 結果を引き渡すための共通の変数を準備
    Dim result As String = ""

    '(2) 別スレッド処理完了後に呼び出すためのDelegate を準備
    Delegate Sub asyncReadDateDelegate()

    '(3) 別スレッドで実行する関数
    Private Sub asyncReadData()
        result = ReadData(friendsTimelineUrl, user, pass)
        '(6) 別スレッドでの処理終了後の処理の実行
        Invoke(New asyncReadDateDelegate(AddressOf writeFriendsTimeline))
    End Sub

    Private Sub loadFriendsTimeline()
        ListBox1.Items.Clear()

        '(4) 別スレッドを呼び出す処理
        Dim newthread As New System.Threading.Thread(AddressOf asyncReadData)
        newthread.Start()
    End Sub

    '(5) 別スレッド処理後の関数
    Private Sub writeFriendsTimeline()
        '(5) 今回別スレッドで行っている処理はコメントアウト
        'Dim result As String = ReadData(friendsTimelineUrl, user, pass)

        If result <> "" Then
            Dim doc As XmlDocument = New XmlDocument()
            doc.LoadXml(result)
            Dim nodes As XmlNodeList = doc.SelectNodes("//statuses/status")
            For Each node As XmlNode In nodes
                Dim content As New twitt
                content.text = node.SelectSingleNode("text").InnerText
                content.name = node.SelectSingleNode("user/screen_name").InnerText
                content.time = node.SelectSingleNode("created_at").InnerText
                ListBox1.Items.Add(content)
            Next
            ListBox1.SelectedIndex = 0
        End If
    End Sub

    Private Sub frmFriendsTimeline_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim rkey As RegistryKey = Registry.CurrentUser.OpenSubKey("Software\Edtter", True)
        If Not rkey Is Nothing Then
            user = CType(rkey.GetValue("user"), String)
            pass = utility.DecryptString(CType(rkey.GetValue("pass"), String), key)
        Else
            frmLogin.ShowDialog()
        End If
        loadFriendsTimeline()
    End Sub



    Private Sub ListBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBox1.SelectedIndexChanged
        TextBox1.Text = CType(ListBox1.SelectedItem, twitt).text
        Label1.Text = CType(ListBox1.SelectedItem, twitt).name
        Label2.Text = CType(ListBox1.SelectedItem, twitt).time
    End Sub

    Private Sub pictReload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictReload.Click
        loadFriendsTimeline()
    End Sub

    Private Sub pictExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        Application.Exit()
    End Sub

    Private Sub pictUser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictUser.Click
        If Label1.Text <> "" Then
            frmUserTimeline.twittuser = Label1.Text
            frmUserTimeline.ShowDialog()
        End If
    End Sub

    Private Sub pictTwitt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictTwitt.Click
        frmUpdate.ShowDialog()
    End Sub

    Private Sub pictAccount_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictAccount.Click
        frmLogin.ShowDialog()
        loadFriendsTimeline()
    End Sub


    Private Sub pictExit_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pictExit.Click
        Application.Exit()
    End Sub
End Class

Public Class twitt

    Public name As String
    Public time As String
    Public text As String

    Public Overrides Function ToString() As String
        Return name & ":" & text
    End Function

End Class
