﻿Imports System.Runtime.InteropServices

Public Class Form1

    Dim Time As Integer = 180

    <DllImport("CoreDll.DLL")> _
    Private Shared Function PlaySound( _
        ByVal szSound As String, _
        ByVal hMod As IntPtr, _
        ByVal flags As Integer) As Integer
    End Function

    Const SND_FILENAME As Integer = &H20000 'ファイル名で指定

    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        'Me.Timer1.Enabled = True
        PlayPause()
    End Sub

    Private Sub PlayPause()
        If Me.Timer1.Enabled = True Then
            Me.Timer1.Enabled = False
        Else
            Me.Timer1.Enabled = True
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        Time = Time - 1

        If Time <= 0 Then
            Me.Timer1.Enabled = False
            'MessageBox.Show("時間です")
            RingSound(5)
        End If

        Dim minutes As Integer = Int(Time / 60)
        Dim seconds As Integer = Time Mod 60
        Me.lblTime.Text = String.Format("{0:00}:{1:00}", minutes, seconds)

    End Sub

    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        Reset()
    End Sub

    Private Sub Reset()
        Me.Timer1.Enabled = False
        Time = 180
        lblTime.Text = "03:00"
    End Sub

    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem1.Click
        PlayPause()
    End Sub

    Private Sub MenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem2.Click
        Reset()
    End Sub

    Private Sub btnFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnFileOpen.Click
        ' ダイアログボックスを開いたときの戻り値用の変数
        Dim result As DialogResult
        ' ダイアログボックスを開いてファイル選択をさせる
        result = Me.OpenFileDialog1.ShowDialog()
        ' OKを押したときは処理をする（Cancel のときは処理をしない）
        If result = Windows.Forms.DialogResult.OK Then
            'テキストボックスに選択したファイル名を入れる
            Me.txtFile.Text = OpenFileDialog1.FileName
            Me.btnPlay.Enabled = True
        End If
    End Sub

    Private Sub btnPlay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPlay.Click
        If System.IO.File.Exists(Me.txtFile.Text) Then
            RingSound()
        Else
            MessageBox.Show("ファイルがありません")
        End If
    End Sub

    Private Sub RingSound()
        PlaySound(Me.txtFile.Text, IntPtr.Zero, SND_FILENAME)
    End Sub

    Private Sub RingSound(ByVal count As Integer)
        Dim i As Integer
        For i = 1 To count
            RingSound()
        Next
    End Sub

    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        ' 既に登録されていないかチェックする
        Dim i As Integer
        For i = 1 To lstFileList.Items.Count - 1
            If Me.txtFile.Text = lstFileList.Items.Item(i).ToString() Then
                Return
            End If
        Next
        ' リストボックスにWavファイルのパスを登録する
        Me.lstFileList.Items.Add(Me.txtFile.Text)
    End Sub

    Private Sub lstFileList_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lstFileList.SelectedIndexChanged
        'リストボックスで選択された項目をテキストボックスに反映する
        Me.txtFile.Text = Me.lstFileList.SelectedItem.ToString()
    End Sub
End Class
