﻿Public Class Form1

    Public penColor As Color
    Public penSize As Integer
    Private bmp As Bitmap
    Private g As Graphics
    Private pos As Point
    Private inipath As String = _
        System.IO.Path.GetDirectoryName( _
            System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase _
            ).ToString + "\picturepaint.ini"

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        penColor = Color.Blue
        penSize = 12
        bmp = New Bitmap(Me.Width, Me.Height)
        g = Graphics.FromImage(bmp)
        g.Clear(Color.White)
        readini()
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        pos.X = e.X
        pos.Y = e.Y
    End Sub

    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        Dim brush As New SolidBrush(penColor)
        g.FillEllipse(brush, e.X - penSize / 2, e.Y - penSize / 2, penSize, penSize)
        Dim pen As New Pen(penColor, penSize)
        g.DrawLine(pen, pos.X, pos.Y, e.X, e.Y)
        pos.X = e.X
        pos.Y = e.Y
        drawbitmap()
        brush.Dispose()
    End Sub

    '画面のちらつきが発生する場合は下の2行のコメントを解除すると改善する場合があります
    'Protected Overrides Sub OnPaintBackground(ByVal e As System.Windows.Forms.PaintEventArgs)
    'End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        drawbitmap()
    End Sub

    Private Sub drawbitmap()
        Me.CreateGraphics().DrawImage(bmp, 0, 0)
    End Sub

    Private Sub MenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuItem1.Click
        Form2.ShowDialog()
    End Sub

    Private Sub MenuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuFileOpen.Click
        If Me.OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            loadBitmapFromFile(Me.OpenFileDialog1.FileName)
        End If
    End Sub

    Private Sub MenuCamera_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuCamera.Click
        Dim dlg As New Microsoft.WindowsMobile.Forms.CameraCaptureDialog
        If dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            loadBitmapFromFile(dlg.FileName)
        End If
    End Sub

    Private Sub loadBitmapFromFile(ByVal file As String)
        Dim img As Bitmap = New Bitmap(file)
        Dim h As Integer = ClientRectangle.Width * img.Height / img.Width
        Dim m As Integer = (ClientRectangle.Height - h) / 2
        g.DrawImage(img, _
                    New Rectangle(0, m, ClientRectangle.Width, h), _
                    New Rectangle(0, 0, img.Width, img.Height), _
                    GraphicsUnit.Pixel)
        img.Dispose()
    End Sub

    Private Sub MenuSaveAs_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuSaveAs.Click

        If Me.SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            Dim fmt As Imaging.ImageFormat
            Select Case Me.SaveFileDialog1.FilterIndex
                Case 1
                    fmt = Imaging.ImageFormat.Jpeg
                Case 2
                    fmt = Imaging.ImageFormat.Bmp
                Case 3
                    fmt = Imaging.ImageFormat.Gif
                Case 4
                    fmt = Imaging.ImageFormat.Png
                Case Else
                    fmt = Imaging.ImageFormat.Jpeg
            End Select
            Try
                Me.bmp.Save(Me.SaveFileDialog1.FileName, fmt)
            Catch ex As Exception
                MessageBox.Show("保存できませんでした")
            End Try
        End If
    End Sub

    Private Sub MenuNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuNew.Click
        If MessageBox.Show( _
            "画像を消去します", _
            "新規作成", _
            MessageBoxButtons.OKCancel, _
            MessageBoxIcon.None, _
            MessageBoxDefaultButton.Button2) _
                = Windows.Forms.DialogResult.OK Then
            g.Clear(Color.White)
        End If
    End Sub

    Private Sub MenuExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MenuExit.Click
        If MessageBox.Show( _
            "終了します", _
            "終了", _
            MessageBoxButtons.OKCancel, _
            MessageBoxIcon.None, _
            MessageBoxDefaultButton.Button2) _
                = Windows.Forms.DialogResult.OK Then
            writeini()
            Application.Exit()
        End If
    End Sub

    Private Sub writeini()

        Try
            Dim sw As IO.StreamWriter = _
            New IO.StreamWriter(inipath, _
                False, System.Text.Encoding.GetEncoding("Shift-JIS"))
            sw.Write("size=")
            sw.WriteLine(penSize.ToString)
            sw.Write("color=")
            sw.WriteLine(penColor.ToArgb)
            sw.WriteLine()
            sw.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub readini()
        If System.IO.File.Exists(inipath) Then
            Dim Reader As New IO.StreamReader(inipath, _
                System.Text.Encoding.GetEncoding("Shift-JIS"))
            Dim Items() As String
            Dim Line As String = Reader.ReadLine
            Do Until IsNothing(Line)
                Items = Line.Split("=")
                Select Case (Items(0))
                    Case "size"
                        penSize = Integer.Parse(Items(1))
                    Case "color"
                        penColor = Color.FromArgb(Integer.Parse(Items(1)))
                End Select
                Line = Reader.ReadLine
            Loop
            Reader.Close()
        End If
    End Sub
End Class
